Qwt User's Guide: QwtRoundScaleDraw Class Reference

Qwt User's Guide 6.1.4

Public Member Functions | Protected Member Functions | List of all members
QwtRoundScaleDraw Class Reference

A class for drawing round scales. More...

`#include <qwt_round_scale_draw.h>`

Inheritance diagram for QwtRoundScaleDraw:
[legend]

## Public Member Functions
| QwtRoundScaleDraw ()
| Constructor. More...
virtual | ~QwtRoundScaleDraw ()
| Destructor.
void | setRadius (double radius)
double | radius () const
void | moveCenter (double x, double y)
| Move the center of the scale draw, leaving the radius unchanged.
void | moveCenter (const QPointF &)
QPointF | center () const
| Get the center of the scale.
void | setAngleRange (double angle1, double angle2)
| Adjust the baseline circle segment for round scales. More...
virtual double | extent (const QFont &) const
Public Member Functions inherited from QwtAbstractScaleDraw
| QwtAbstractScaleDraw ()
| Constructor. More...
virtual | ~QwtAbstractScaleDraw ()
| Destructor.
void | setScaleDiv (const QwtScaleDiv &)
const QwtScaleDiv & | scaleDiv () const
void | setTransformation (QwtTransform *)
const QwtScaleMap & | scaleMap () const
QwtScaleMap & | scaleMap ()
void | enableComponent (ScaleComponent, bool enable=true)
bool | hasComponent (ScaleComponent) const
void | setTickLength (QwtScaleDiv::TickType, double length)
double | tickLength (QwtScaleDiv::TickType) const
double | maxTickLength () const
void | setSpacing (double)
| Set the spacing between tick and labels. More...
double | spacing () const
| Get the spacing. More...
void | setPenWidth (int width)
| Specify the width of the scale pen. More...
int | penWidth () const
virtual void | draw (QPainter *, const QPalette &) const
| Draw the scale. More...
virtual QwtText | label (double) const
| Convert a value into its representing label. More...
void | setMinimumExtent (double)
| Set a minimum for the extent. More...
double | minimumExtent () const

## Protected Member Functions
virtual void | drawTick (QPainter *, double value, double len) const
virtual void | drawBackbone (QPainter *) const
virtual void | drawLabel (QPainter *, double val) const
Protected Member Functions inherited from QwtAbstractScaleDraw
void | invalidateCache ()
const QwtText & | tickLabel (const QFont &, double value) const
| Convert a value into its representing label and cache it. More...

## Additional Inherited Members
Public Types inherited from QwtAbstractScaleDraw
enum | ScaleComponent { Backbone = 0x01, Ticks = 0x02, Labels = 0x04 }
typedef QFlags< ScaleComponent > | ScaleComponents
| Scale components.

## Detailed Description

A class for drawing round scales.

QwtRoundScaleDraw can be used to draw round scales. The circle segment can be adjusted by setAngleRange(). The geometry of the scale can be specified with moveCenter() and setRadius().

After a scale division has been specified as a QwtScaleDiv object using QwtAbstractScaleDraw::setScaleDiv(const QwtScaleDiv &s), the scale can be drawn with the QwtAbstractScaleDraw::draw() member.

## Constructor & Destructor Documentation

## ◆ QwtRoundScaleDraw()

QwtRoundScaleDraw::QwtRoundScaleDraw | ( |  | ) |

Constructor.

The range of the scale is initialized to [0, 100], The center is set to (50, 50) with a radius of 50. The angle range is set to [-135, 135].

## Member Function Documentation

## ◆ drawBackbone()

void QwtRoundScaleDraw::drawBackbone | ( | QPainter * | painter | ) | const
| protectedvirtual

Draws the baseline of the scale

Parameters

  painter | Painter

See also
  drawTick(), drawLabel()

Implements QwtAbstractScaleDraw.

## ◆ drawLabel()

void QwtRoundScaleDraw::drawLabel | ( | QPainter * | painter,
|  | double | value
| ) |  | const
| protectedvirtual

Draws the label for a major scale tick

Parameters

  painter | Painter
  value | Value

See also
  drawTick(), drawBackbone()

Implements QwtAbstractScaleDraw.

## ◆ drawTick()

void QwtRoundScaleDraw::drawTick | ( | QPainter * | painter,
|  | double | value,
|  | double | len
| ) |  | const
| protectedvirtual

Draw a tick

Parameters

  painter | Painter
  value | Value of the tick
  len | Lenght of the tick

See also
  drawBackbone(), drawLabel()

Implements QwtAbstractScaleDraw.

## ◆ extent()

double QwtRoundScaleDraw::extent | ( | const QFont & | font | ) | const
| virtual

Calculate the extent of the scale

The extent is the distance between the baseline to the outermost pixel of the scale draw. radius() + extent() is an upper limit for the radius of the bounding circle.

Parameters

  font | Font used for painting the labels

Returns
  Calculated extent

See also
  setMinimumExtent(), minimumExtent()

Warning
  The implemented algorithm is not too smart and calculates only an upper limit, that might be a few pixels too large

Implements QwtAbstractScaleDraw.

## ◆ moveCenter()

void QwtRoundScaleDraw::moveCenter | ( | const QPointF & | center | ) |

Move the center of the scale draw, leaving the radius unchanged

Parameters

  center | New center

See also
  setRadius()

## ◆ radius()

double QwtRoundScaleDraw::radius | ( |  | ) | const

Get the radius

Radius is the radius of the backbone without ticks and labels.

Returns
  Radius of the scale

See also
  setRadius(), extent()

## ◆ setAngleRange()

void QwtRoundScaleDraw::setAngleRange | ( | double | angle1,
|  | double | angle2
| ) |  |

Adjust the baseline circle segment for round scales.

The baseline will be drawn from min(angle1,angle2) to max(angle1, angle2). The default setting is [ -135, 135 ]. An angle of 0 degrees corresponds to the 12 o'clock position, and positive angles count in a clockwise direction.

Parameters

  angle1 |
  angle2 | boundaries of the angle interval in degrees.

Warning
  - The angle range is limited to [-360, 360] degrees. Angles exceeding this range will be clipped.
  - For angles more or equal than 360 degrees above or below min(angle1, angle2), scale marks will not be drawn.
  - If you need a counterclockwise scale, use QwtScaleDiv::setInterval()

## ◆ setRadius()

void QwtRoundScaleDraw::setRadius | ( | double | radius | ) |

Change of radius the scale

Radius is the radius of the backbone without ticks and labels.

Parameters

  radius | New Radius

See also
  moveCenter()